########################################################################
########################################################################
# Please edit following macros suitable for your computer
#   CPP_FLAGS    ( -Dxxxx, see RSDFT Users Guide )
#   INCLUDE_DIR  ( Directory of modules and include files )
#   FFTW_L       ( link to FFTW )
#   Eigen_L      ( link to Eigen )
#   LAPACK_L     ( link to BLAS and LAPACK/ScaLAPACK ) 
#   FFLAGS0      ( preprocessor and compile options )
#   LFLAGS0      ( link options )
#   OMPFLAG      ( OpenMP options )
########################################################################
###################################### Default ( do not edit ) #########
INCLUDE_DIR = -I../
CPP_FLAGS =
LFLAGS0   =
OMPFLAG   =
########################################################################
####### With the following options, an expedient code may be generated #
########################################################################
#FC = mpif90
#FFLAGS0   = -cpp
#LAPACK_L  = -llapack -lblas
#CPP_FLAGS = -D_LAPACK_
########################################################################
####### If you try to generate the code suitable for your systems,   ###
####### edit followings adequately                                   ###
########################################################################
########################### preprocessor options, links and includes ###
########################################################################
####################### Generate REAL8 code ( RSMOL is supported ) #####
CPP_FLAGS := -D_DRSDFT_ $(CPP_FLAGS)
####################### Spline interpolation is use for nonlocal pp ####
CPP_FLAGS := -D_SPLINE_ $(CPP_FLAGS)
######################### LAPACK is used ( ScaLAPACK is not used ) #####
#CPP_FLAGS := -D_LAPACK_ $(CPP_FLAGS)
##################################################### FFTE is used #####
#CPP_FLAGS := -D_FFTE_ $(CPP_FLAGS)
##################################################### FFTW is used #####
CPP_FLAGS := -D_FFTW_ $(CPP_FLAGS)
#INCLUDE_DIR := -I$(MKLROOT)/include/fftw $(INCLUDE_DIR)
#FFTW_L = -L/data1/group4/iwata/mklt/fftw3xf_cdft/lib/intel64 -lfftw3x_cdft
#INCLUDE_DIR := -I$(HOME)/fftw/include/ $(INCLUDE_DIR)
#FFTW_L = -L$(HOME)/fftw/lib/ -lfftw3_mpi -lfftw3 -lm
INCLUDE_DIR := -I$(FFTW_DIR)/include/ $(INCLUDE_DIR)
FFTW_L = -L$(FFTW_DIR)/lib/ -lfftw3_mpi -lfftw3 -lm
############################################################ LibXC #####
#CPP_FLAGS := -D_LIBXC_ $(CPP_FLAGS)
#INCLUDE_DIR := -I/home/iwata/libxc/include/ $(INCLUDE_DIR)
#LIBXC_L = /home/iwata/libxc/lib/libxcf90.a \
#          /home/iwata/libxc/lib/libxc.a
################################################## Grimme's DFT-D3 #####
#CPP_FLAGS := -D_DFTD3_ $(CPP_FLAGS)
#INCLUDE_DIR := -I/home/iwata/DFT-D3/lib/ $(INCLUDE_DIR)
#DFTD3_L = /home/iwata/DFT-D3/lib/libdftd3.a
########################################################### Others #####
#CPP_FLAGS := -D_NO_ERF_ $(CPP_FLAGS)
CPP_FLAGS := -D_NO_MPI_INPLACE_ $(CPP_FLAGS)
#CPP_FLAGS := -D_NO_MPI_COMPLEX16_ $(CPP_FLAGS)
#CPP_FLAGS := -D_DIV_ALLREDUCE_ $(CPP_FLAGS)
#CPP_FLAGS := -D_NO_QPRECISION_ $(CPP_FLAGS)
########################################################################
################################################# compiler & options ###
########################################################################
##### INTEL                                                        #####
#FC = mpif90
#FFLAGS0 = -cpp
#FFLAGS0 = -cpp -fast -xHost
#FFLAGS0 = -cpp -C
#OMPFLAG = -openmp
#LAPACK_L = -lmkl_scalapack_lp64 -lmkl_blacs_openmpi_lp64 \
           -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core \
           -lguide -lpthread
#LAPACK_L = -lmkl_scalapack_lp64 -lmkl_blacs_openmpi_lp64 \
           -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core \
           -lpthread
#LAPACK_L = -lmkl_scalapack_lp64 -lmkl_blacs_openmpi_lp64 \
           -lmkl_intel_lp64 -lmkl_sequential -lmkl_core
#LAPACK_L = -lm /Users/lhan/.homebrew/opt/scalapack/lib/libscalapack.dylib -lblas
#LAPACK_L = -mkl=sequential -lmkl_scalapack_lp64 -lmkl_blacs_sgimpt_lp64 -lmpi
########################################################################
##### INTEL(2)                                                     #####
FC = mpiifort
FFLAGS0 = -cpp -xCORE-AVX2 -O3 -mcmodel=large
#FFLAGS0 = -cpp -C -traceback
#OMPFLAG = -qopenmp
#LAPACK_L = -L$(MKLROOT) -lmkl_cdft_core -mkl=cluster
LAPACK_L = -mkl=cluster
########################################################################
##### INTEL(Oakforest-PACS)                                        #####
#FC = mpiifort
#FFLAGS0 = -cpp -axMIN-AVX512 -align array64byte
#FFLAGS0 = -cpp -C -traceback -O2 -g
#OMPFLAG = -qopenmp
#LAPACK_L = -lmkl_scalapack_lp64 \
#           -lmkl_intel_lp64 \
#           -lmkl_intel_thread \
#           -lmkl_core \
#           -lmkl_blacs_intelmpi_lp64 -liomp5 -lpthread
#LAPACK_L = -mkl=cluster
########################################################################
########################################################################
##### PGF                                                          #####
#FFLAGS0 = -Mpreprocess -O3
#FFLAGS0 = -Mpreprocess -fastsse
#FFLAGS0 = -Mpreprocess -C
#FFLAGS0 = -Mpreprocess -C -Mchkfpstk -Mchkptr -Mchkstk -Minform=inform
#OMPFLAG = -mp
#FFLAGS0 = -fastsse -O3 -tp amd64 -mp -Mpreprocess
#FFLAGS0 = -fastsse -O3 -tp amd64e -mp -Mpreprocess
#FFLAGS0 = -fastsse -O3 -tp barcelona-64 -mp -Mpreprocess
#FFLAGS0 = -fastsse -O3 -tp shanghai-64 -mp -Mpreprocess
#FFLAGS0 = -Mcuda
#LFLAGS0 = -Mcuda=cc20
########################################################################
##### OPENMPI                                                      #####
#FC = openmpif90
#FFLAGS0 = -cpp
#FFLAGS0 = -cpp -fcheck=all -fbacktrace
#OMPFLAG= -fopenmp
#LAPACK_L = -llapack -lblas
########################################################################
##### SX-ACE                                                       #####
#FC = sxmpif03
#FFLAGS0 = -Ep
#OMPFLAG= -fopenmp
#LAPACK_L = -L/SX/usr/lib/f03/ -lscalapack -lblacsF90init -lblacs -lblacsF90init -llapack -lblas -lmpi
########################################################################
##### SX-Aurora TSUBASA                                            #####
#FC = mpinfort
#FFLAGS0 = -O4 -fpp
#LAPACK_L = -lscalapack -llapack -lblas_sequential
#FFTW_L = -laslfftw3_mpi -lasl_mpi_sequential
#OMPFLAG= -fopenmp
#LAPACK_L = -lscalapack -llapack -lblas_openmp
#FFTW_L = -laslfftw3_mpi -lasl_mpi_openmp
########################################################################
#####  K computer                                                  #####
#FC = mpifrtpx
#FFLAGS0 = -Kvisimpact,preex,array_private,auto,ocl,NOFLTLD \
        -Ksimd=2 -Kopenmp -Ktemparraystack -Koptmsg=2 \
        -X9 -V -Ec -Qa,d,i,p,t,x -Cpp -Ccpp
#LFLAGS0 = ${FFLAGS0} -Ntl_trt
#LAPACK_L = -SSL2BLAMP -SCALAPACK
#INCLUDE_DIR = -I../ -I/home/apps/fftw/3.3.3/include/
#FFTW_L = -L/home/apps/fftw/3.3.3/lib64 -lfftw3_mpi -lfftw3 -lm
########################################################################
########################################################################
########################################################################
############################ Do not edit below #########################
########################################################################
#
FFLAGS = $(FFLAGS0) $(OMPFLAG) $(CPP_FLAGS) $(INCLUDE_DIR)
LFLAGS = $(LFLAGS0) $(OMPFLAG)
#
########################################################################
.SUFFIXES:
.SUFFIXES: .o .f .f90
.f.o :
	$(FC) $(FFLAGS) -c $< -o $@
.f90.o :
	$(FC) $(FFLAGS) -c $< -o $@
